<template>
  <v-card>
    <v-card-title
      class="headline grey lighten-2"
      primary-title
    >
      <input v-model="qrcode.name" placeholder="Edit name..." @change="hasChanged()">
      <v-spacer />
      <v-btn absolute right fab small @click.stop="$emit('close')"><v-icon>close</v-icon></v-btn>
    </v-card-title>
    <v-card-text>
      <v-btn v-if="canScanCode()" absolute right fab small @click.stop="scan = !scan"><v-icon>camera_alt</v-icon></v-btn>
      <v-dialog v-model="scan" :overlay-opacity="1" @keydown.esc="scan = false" @click.stop="scan = false">
        <v-btn absolute right fab small @click.stop="scan = false"><v-icon>close</v-icon></v-btn>
        <vue-qr-reader
          v-if="scan"
          :use-back-camera="true"
          :responsive="true"
          @code-scanned="codeScanned"
        />
      </v-dialog>
      <v-textarea v-model="qrcode.value" placeholder="Edit value..." @change="hasCodeChanged()"/>
      <v-combobox
        v-model="qrcode.type"
        :items="Object.entries(types).map((e,i) => ({value:e[0],text:e[1]}))"
        :placeholder="'QR code'"
        @change="hasCodeChanged()"/>
      <l-map ref="map" :zoom="zoom" :center="center" @update:center="updateCenter" @update:zoom="updateZoom">
        <l-tile-layer :url="url" :attribution="attribution"/>
        <l-marker :lat-lng="qrcode.latlng" :draggable="true" @update:latLng="updateMarker"/>
      </l-map>
      <canvas id="code-preview"/>
    </v-card-text>
  </v-card>
</template>

<script>
  import bwipjs from 'bwip-js'
  import {LMap, LMarker, LTileLayer} from 'vue2-leaflet'
  import VueQrReader from 'vue-qr-reader/dist/lib/vue-qr-reader.umd.js'

  export default {
    name: "qrcode-tile",
    components: {
      VueQrReader,
      LMap,
      LTileLayer,
      LMarker
    },
    props: {
      qrcode: {
        type: Object,
        required: true
      }
    },
    data() {
      return {
        scan: false,
        center: this.qrcode.latlng,
        zoom: 15,
        url: 'https://{s}.tile.osm.org/{z}/{x}/{y}.png',
        attribution: '&copy; <a href="https://osm.org/copyright">OpenStreetMap</a> contributors',
        types: {
          'qrcode': 'QR code',
          'azteccode': 'Aztec code',
          'datamatrix': 'Data Matrix',
          'code128': 'Code 128',
          'code2of5': 'Code 25',
          'ean13': 'EAN-13',
        },
      }
    },
    created() {
      if (!this.qrcode.latlng) {
        this.center = this.qrcode.latlng = {lat: 45.19867, lng: 5.72434}
        this.zoom = 5
        navigator.geolocation.getCurrentPosition((position) => {
          // eslint-disable-next-line no-undef
          this.center = this.qrcode.latlng = L.latLng(position.coords.latitude, position.coords.longitude)
          this.hasChanged()
        })
      }
      this.preview()
    },
    methods: {
      updateCenter(latlng) {
        this.center = latlng
      },
      updateZoom(zoom) {
        this.zoom = zoom
      },
      updateMarker(latlng) {
        this.qrcode.latlng = latlng
        this.hasChanged()
      },
      init() {
        this.qrcode.type = this.types[this.qrcode.type] || this.qrcode.type
        setTimeout(() => {
          this.center = this.qrcode.latlng
          this.$refs.map.mapObject.invalidateSize()
        }, 100)
      },
      hasCodeChanged() {
        this.preview()
        this.hasChanged()
      },
      hasChanged() {
        this.$emit('change')
      },
      preview() {
        try {
          bwipjs.toCanvas('code-preview', {
            bcid:        this.qrcode.type.value || this.qrcode.type, // Barcode type
            text:        this.qrcode.value,// Text to encode
            scale:       3,                // 3x scaling factor
            includetext: true,             // Show human-readable text
            textxalign:  'center',         // Always good to set this
          });
        } catch (e) {
            // eslint-disable-next-line no-console
            console.error(e)
        }
      },
      canScanCode() {
        return !this.qrcode.type || this.qrcode.type === 'qrcode'
      },
      codeScanned(code) {
        this.qrcode.value = code
        this.scan = false
      }
    }
  }
</script>

<style scoped>
  @font-face {
    font-family: 'qrcode';
    src: url('/qr-code-webfont.woff2') format('woff2'),
        url('/qr-code-webfont.woff') format('woff');
    font-weight: normal;
    font-style: normal;
  }
  .v-card__title > input {
    width: 100%;
  }
  div.leaflet-container {
    margin: 0px auto;
    width: 100%;
    height: 320px;
  }
  #code-preview {
    display: block;
    margin: auto;
    margin-top: 30px;
  }
</style>